
# This file was generated by the SOM Compiler.
# FileName: penobj.sc.
# Generated using:
#     SOM Precompiler spc: 1.22
#     SOM Emitter emitcsc: 1.10

/*
 *  SCC: @(#) 42 12/4/92 16:37:08 1.1 @(#)
 *  Module Header
 * 
 *  Module Name: PENOBJ
 * 
 *  OS/2 Presentation Manager Workplace class definitions
 * 
 *  Copyright (c) International Business Machines Corporation 1992
 * 
 */

#include "wpobject.sc"

class: PenObject, 
    external stem = Penobj, local, external prefix = pob_, 
    classprefix = pobM_, major version = 1, minor version = 2, 
    file stem = penobj;

    -- 
    --  CLASS: PenObject
    -- 
    --  CLASS HIERARCHY:
    --     SOMObject
    --        WPObject
    --              PenObject
    -- 
    --  DESCRIPTION:
    --     This is the replacement class for the WPObject class.  It provides
    --     the instance data and methods needed to support the OS/2 Pen
    --     extensions.
    -- 
    --     An instance of this class cannot be created as a Workplace object.
    -- 
    --     This class first subclasses the WPObject class and then replaces
    --     it's parent class.
    -- 


parent class: WPObject;


release order:
    penAddObjectEventPage, penAddObjectOverridesPage, penInvokeGestureHelp, 
    penNotifyChangeofSystemMappings;

methods:


    ULONG    penInvokeGestureHelp(), name lookup;

    -- 
    --  METHOD: penInvokeGestureHelp                           ( ) PRIVATE
    --                                                         (X) PUBLIC
    --  PURPOSE:
    --    Opens settings notebook of particular object to the Gesture
    --    page.
    -- 

    ULONG    penAddObjectEventPage(HWND hwndNotebook,
		PVOID pMappingInfo), name lookup;

    -- 
    --  METHOD: penAddObjectEventPage                          ( ) PRIVATE
    --                                                         (X) PUBLIC
    --  PURPOSE:
    --    Add the recognition event page to all workplace objects that
    --    are of one of the predefined types.
    -- 

    ULONG    penAddObjectOverridesPage(HWND hwndNotebook);

    -- 
    --  METHOD: penAddObjectOverridesPage                       (X) PRIVATE
    --                                                         ( ) PUBLIC
    --  PURPOSE:
    --    Add an Overrides page to allow the user to override Pen system
    --    variables.
    -- 

    override wpAddSettingsPages;

    -- 
    --  METHOD: wpAddSettingsPages                             ( ) PRIVATE
    --                                                         (X) PUBLIC
    --  PURPOSE:
    --    Add our own settings page to give the user access to the recognition
    --    profile editor so that the recognition profile mappings for this
    --    object may be changed.
    -- 

    override wpInitData;

    -- 
    --  REMARKS:
    --    Initialize the recognition profile name instance data for
    --    this object.
    -- 

    override wpUnInitData;

    -- 
    --  REMARKS:
    --    Release any resources that get allocated during the wpInitData
    --    processing.
    -- 

    override wpCreateAnother;

    -- 
    --  REMARKS:
    --    Setup PenObject information on Create another....
    -- 

    override wpRestoreState;

    -- 
    --  REMARKS:
    --    Retreive the recognition profile name for this object instance
    --    and set the instance variable for this parameter.
    -- 

    override wpSaveState;

    -- 
    --  REMARKS:
    --    Save the instance variable value.
    -- 

    override wpFree;

    -- 
    --  REMARKS:
    --    Need to free any pen specific information associated with this
    --    Program or ProgramFile Object.
    -- 

    override wpclsQueryIcon, class;

    -- From WPObject

